#!/usr/bin/perl

while (@ARGV)
{
    my $file = shift;

    die "Can't find file \"$file\""
	unless -f $file;

    die "Still failed to opening \"$file\""
	unless open(DEB, "<$file");
    binmode DEB;

    my $magic;
    die "Could not read magic"
	unless read(DEB,$magic, 8) == 8;

    die "Magic '$magic' is not for .deb ar"
	unless $magic eq "!<arch>\n";

    # ar_name[16];    +00
    # ar_date[12];    +16 (= seconds since)
    # ar_uid[6]       +28 (= "0     ")
    # ar_gid[6]       +34 (= "0     ")
    # ar_mode[8]      +40 (= "100644  ")
    # ar_size[10];    +48
    # ar_fmag[2];     +58 (= "`\n")
    # -------------------
    #                 =60
    print "\nChecking $file\n";
    my $hdr;
    while (read(DEB, $hdr, 60) == 60)
    {
	my $member = substr($hdr, 0, 16);
	$member =~ s/\s*$//g;
	my $size = substr($hdr, 48, 10);
	print "\t'$member' size=$size\n";
	if (substr($hdr, 58, 2) ne "`\n")
	{
	    print "\thas bad header magic\n";
	    last;
	}
	$size += 1 if ($size & 1);
	seek DEB,$size,1;
    }
    close DEB;
}
